
(use byte-blob-stream byte-blob test streams)


(define a (list->byte-blob (list 1 2 3 4 )))
(define b (byte-blob-replicate 10 5))
   


(test-group "byte-blob-stream test"

	    (test (sprintf "byte-blob-stream-cons" ) 
		   '(1 2 3 4 5 5 5 5 5 5 5 5 5 5)
		   (byte-blob-stream->list 
		    (byte-blob-stream-cons 
		     a (byte-blob-stream-cons b stream-null))))

	    (test (sprintf "byte-blob-stream-car" ) 
		  1
		  (byte-blob-stream-car
		   (byte-blob-stream-cons 
		    a (byte-blob-stream-cons b stream-null))))

	    (test (sprintf "byte-blob-stream-cdr" ) 
		   '(2 3 4 5 5 5 5 5 5 5 5 5 5)
		   (byte-blob-stream->list 
		    (byte-blob-stream-cdr
		     (byte-blob-stream-cons 
		      a (byte-blob-stream-cons b stream-null)))))

	    (test (sprintf "byte-blob-stream-ref" ) 
		   4
		   (byte-blob-stream-ref  
		     (byte-blob-stream-cons 
		      a (byte-blob-stream-cons b stream-null))
		     3))

	    (test (sprintf "byte-blob-stream-append+reverse" ) 
		   '(1 2 3 4 5 5 5 5 5 5 5 5 5 5  5 5 5 5 5 5 5 5 5 5 4 3 2 1)
		   (byte-blob-stream->list
		    (byte-blob-stream-append
		     (byte-blob-stream-cons 
		      a (byte-blob-stream-cons b stream-null))
		     (byte-blob-stream-reverse
		      (byte-blob-stream-cons 
		       a (byte-blob-stream-cons b stream-null))))))

	    (test (sprintf "byte-blob-stream-intersperse" ) 
		   '(1 6 2 6 3 6 4 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6  
		       5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 4 6 3 6 2 6 1)
		   (byte-blob-stream->list
		    (byte-blob-stream-intersperse 
		     (byte-blob-stream-append
		      (byte-blob-stream-cons 
		       a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		     6)
		     ))

	    (test (sprintf "byte-blob-stream-take" ) 
		   '(1 6 2 6 3 6 4)
		   (byte-blob-stream->list
		    (byte-blob-stream-take
		     (byte-blob-stream-intersperse 
		      (byte-blob-stream-append
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		      6)
  		     7)))
	    
	    (test (sprintf "byte-blob-stream-drop" ) 
		   '(6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6  
		       5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 4 6 3 6 2 6 1)
		   (byte-blob-stream->list
		    (byte-blob-stream-drop
		     (byte-blob-stream-intersperse 
		      (byte-blob-stream-append
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		      6)
  		     7)))
	    
	    (test (sprintf "byte-blob-stream-drop" ) 
		   '(4 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6  
		       5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 4 6 3 6 2 6 1)
		   (byte-blob-stream->list
		    (byte-blob-stream-drop
		     (byte-blob-stream-intersperse 
		      (byte-blob-stream-append
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		      6)
  		     6)))

	    (test (sprintf "byte-blob-stream-drop" ) 
		   '(5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6  
		       5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 5 6 4 6 3 6 2 6 1)
		   (byte-blob-stream->list
		    (byte-blob-stream-drop
		     (byte-blob-stream-intersperse 
		      (byte-blob-stream-append
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		      6)
  		     8)))
	    
	    (test (sprintf "byte-blob-stream-span" ) 
		   '(3 6 4 6)
		   (byte-blob-stream->list
		    (byte-blob-stream-span
		     (byte-blob-stream-intersperse 
		      (byte-blob-stream-append
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		      6)
  		     4 8)))
	    
	    (test (sprintf "byte-blob-stream-map" ) 
		   '(10 60 20 60 30 60 40 60 50 60 50 60 
			50 60 50 60 50 60 50 60 50 60 50 
			60 50 60 50 60 50 60 50 60 50 60 
			50 60 50 60 50 60 50 60 50 60 50 
			60 50 60 40 60 30 60 20 60 10)
		   (byte-blob-stream->list
		    (byte-blob-stream-map
		     (lambda (x) (* x 10))
		     (byte-blob-stream-intersperse 
		      (byte-blob-stream-append
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))
		      (byte-blob-stream-reverse
		       (byte-blob-stream-cons 
			a (byte-blob-stream-cons b stream-null))))
		      6)))
		   )

	    (test (sprintf "byte-blob-stream-fold-left" ) 
		  (+ 10 10 50 50 (* 6 27))
		  (byte-blob-stream-fold-left
		   (lambda (x ax) (+ x ax)) 0
		   (byte-blob-stream-intersperse 
		    (byte-blob-stream-append
		     (byte-blob-stream-cons 
		      a (byte-blob-stream-cons b stream-null))
		     (byte-blob-stream-reverse
		      (byte-blob-stream-cons 
		       a (byte-blob-stream-cons b stream-null))))
		    6)))

	    (test (sprintf "byte-blob-stream-fold-right" ) 
		  (- 1 (+ 9 10 50 50 (* 6 27)))
		  (let ((sb (byte-blob-stream-intersperse 
			     (byte-blob-stream-append
			      (byte-blob-stream-cons 
			       a (byte-blob-stream-cons b stream-null))
			      (byte-blob-stream-reverse
			       (byte-blob-stream-cons 
				a (byte-blob-stream-cons b stream-null))))
			     6)))
		    (byte-blob-stream-fold-right
		     (lambda (x ax) (- ax x))
		     (byte-blob-stream-car sb) (byte-blob-stream-cdr sb))
		   ))

	    (test (sprintf "byte-blob-stream-find" ) 
		  '((1 2) (((3 4 5 5 5 5 5 5 5 5 5 5 5 
			       5 5 5 5 5 5 5 5 5 4 3 2 1) 
			    (3 4 5 5 5 5 5 5 5 5 5 5 5 
			       5 5 5 5 5 5 5 5 5 4 3 2 1))))
		  (let ((r (byte-blob-stream-find
			    (list->byte-blob '(3 4 5 5))
			    (byte-blob-stream-append
			     (byte-blob-stream-cons 
			      a (byte-blob-stream-cons b stream-null))
			     (byte-blob-stream-reverse
			      (byte-blob-stream-cons 
			       a (byte-blob-stream-cons b stream-null)))))))
		    (cons (byte-blob-stream->list (car r)) 
			  (map (lambda (l) 
				 (map (lambda (p)
					(list (byte-blob-stream->list (car p))
					      (byte-blob-stream->list (cadr p))))
				      l))
			       (cdr r))))
		   )

)


(test-exit)
